/*
 * hello-writev.c --
 *
 *	This file contains a program which invokes the Linux writev()
 *	system call.
 *
 * Exercise:
 *
 * Statically Compile and run the program. Look at the assembler code
 * generated (objdump -S write, or gcc -S).
 */
  
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/uio.h>

int
main(int argc, char *argv[])
{
    struct iovec iov[2];
    ssize_t n;

    iov[0].iov_base = "Hello ";
    iov[0].iov_len = strlen(iov[0].iov_base);
    iov[1].iov_base = "World\n";
    iov[1].iov_len = strlen(iov[1].iov_base);

    n = writev(STDOUT_FILENO, iov, 2);
    if (n == -1 || n != iov[0].iov_len + iov[1].iov_len) {
	return EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}
